<?php

declare(strict_types=1);

namespace Dedi\SyliusSogenactifPlugin\Controller;

use InvalidArgumentException;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\RouterInterface;

class ConfirmController extends AbstractController
{
    private RouterInterface $router;

    public function __construct(RouterInterface $router)
    {
        $this->router = $router;
    }

    public function __invoke(Request $request)
    {
        $data = $request->get('Data', []);

        $orderId = null;
        foreach (explode('|', $data) as $datum) {
            $exploded = explode('=', $datum);

            if (false === $exploded || !array_key_exists(0, $exploded)) {
                continue;
            }

            if ($exploded[0] === 'orderId' && array_key_exists(1, $exploded)) {
                $orderId = (int)$exploded[1];
                break;
            }
        }

        if (null === $orderId) {
            throw new InvalidArgumentException('Missing order id data from Sogenactif return');
        }

        $request->getSession()->set('sylius_order_id', $orderId);

        return new RedirectResponse($this->router->generate('sylius_shop_order_thank_you'));
    }
}